summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorEugen Wissner <belka@caraus.de>2020-11-30 08:57:34 +0100
committerEugen Wissner <belka@caraus.de>2020-11-30 08:57:34 +0100
commitd44ba0da6efd862ff28db044829f72f28dd1b67f (patch)
tree339568535904adbbd7e2e2864e63f55780526402
downloadslackbuilder-d44ba0da6efd862ff28db044829f72f28dd1b67f.tar.gz
rspamd: Added
-rw-r--r--rspamd/README19
-rw-r--r--rspamd/doinst.sh25
-rw-r--r--rspamd/rc.rspamd.new72
-rwxr-xr-xrspamd/rspamd.SlackBuild130
-rw-r--r--rspamd/rspamd.info10
-rw-r--r--rspamd/slack-desc19
-rw-r--r--rspamd/use-gold-ld.patch16
7 files changed, 291 insertions, 0 deletions
diff --git a/rspamd/README b/rspamd/README
new file mode 100644
index 0000000..705ffd1
--- /dev/null
+++ b/rspamd/README
@@ -0,0 +1,19 @@
+rspamd (An advanced spam filtering system)
+
+Rspamd is an advanced spam filtering system that allows evaluation of
+messages by a number of rules including regular expressions, statistical
+analysis and custom services such as URL black lists. Each message is
+analysed by Rspamd and given a spam score.
+
+According to this spam score and the user's settings Rspamd recommends
+an action for the MTA to apply to the message: for example, to pass, to
+reject or to add a header. Rspamd is designed to process hundreds of
+messages per second simultaneously and has a number of features
+available.
+
+Groupname and Username
+
+You must have the "rspamd" group and user to run this script, for example:
+
+ groupadd -g 359 rspamd
+ useradd -u 359 -s /bin/false -d /dev/null -g rspamd rspamd
diff --git a/rspamd/doinst.sh b/rspamd/doinst.sh
new file mode 100644
index 0000000..14bc815
--- /dev/null
+++ b/rspamd/doinst.sh
@@ -0,0 +1,25 @@
+config() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
+ # toss the redundant copy
+ rm $NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+preserve_perms() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ if [ -e $OLD ]; then
+ cp -a $OLD ${NEW}.incoming
+ cat $NEW > ${NEW}.incoming
+ mv ${NEW}.incoming $NEW
+ fi
+ config $NEW
+}
+
+preserve_perms etc/rc.d/rc.rspamd.new
diff --git a/rspamd/rc.rspamd.new b/rspamd/rc.rspamd.new
new file mode 100644
index 0000000..029932f
--- /dev/null
+++ b/rspamd/rc.rspamd.new
@@ -0,0 +1,72 @@
+#!/bin/sh
+#
+# rspamd startup script for Slackware Linux
+
+NAME=rspamd
+DAEMON=/usr/bin/$NAME
+RSPAMADM=/usr/bin/rspamadm
+PIDFILE=/var/run/rspamd/${NAME}.pid
+CONF=/etc/rspamd/rspamd.conf
+DAEMON_ARGS="-c $CONF -u $NAME -g $NAME"
+
+rspamd_start() {
+ if [ ! -r $CONF ]; then
+ echo "$CONF does not appear to exist. Abort."
+ exit 1
+ fi
+
+ if [ -s $PIDFILE ]; then
+ echo "rspamd appears to be already running?"
+ exit 1
+ fi
+
+ PIDDIR=$(dirname $PIDFILE)
+ mkdir -p $PIDDIR
+ chown $NAME:$NAME $PIDDIR
+ chmod 0750 $PIDDIR
+
+ echo "Starting rspamd ..."
+ $DAEMON $DAEMON_ARGS
+}
+
+rspamd_stop() {
+ if [ ! -s $PIDFILE ]; then
+ echo "$PIDFILE does not exist or is empty."
+ exit 1
+ fi
+
+ PID=$(cat $PIDFILE)
+ echo -n "Stopping rspamd ..."
+ kill -TERM $(cat $PIDFILE)
+ rm -f $PIDFILE
+ echo " done"
+}
+
+rspamd_restart() {
+ rspamd_configtest || return $?
+ rspamd_stop
+ sleep 3
+ rspamd_start
+}
+
+rspamd_configtest() {
+ $RSPAMADM configtest -c $CONF
+}
+
+case "$1" in
+ start)
+ rspamd_start
+ ;;
+ stop)
+ rspamd_stop
+ ;;
+ restart)
+ rspamd_restart
+ ;;
+ configtest)
+ rspamd_configtest
+ ;;
+ *)
+ echo "Usage: $0 {start|stop|restart|configtest}"
+ exit 1
+esac
diff --git a/rspamd/rspamd.SlackBuild b/rspamd/rspamd.SlackBuild
new file mode 100755
index 0000000..89b7cfb
--- /dev/null
+++ b/rspamd/rspamd.SlackBuild
@@ -0,0 +1,130 @@
+#!/bin/sh
+
+# Slackware build script for Rspamd
+
+# Copyright 2018, 2019 Ebben Aries <e@dscp.org>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=rspamd
+VERSION=${VERSION:-2.5}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+UIDGID=359
+if ! getent group $PRGNAM; then
+ echo " You must have the \"$PRGNAM\" group to run this script."
+ echo " # groupadd -g $UIDGID $PRGNAM"
+ exit 1
+elif ! getent passwd $PRGNAM; then
+ echo " You must have the \"$PRGNAM\" user to run this script."
+ echo " # useradd -u $UIDGID -s /bin/false -d /dev/null -g $PRGNAM $PRGNAM"
+ exit 1
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+patch --verbose -p1 < $CWD/use-gold-ld.patch
+
+mkdir -p build
+cd build
+ cmake \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DCONFDIR=/etc/$PRGNAM \
+ -DLIBDIR=/usr/lib${LIBDIRSUFFIX}/$PRGNAM \
+ -DMANDIR=/usr/man \
+ -DENABLE_STATIC=OFF \
+ -DENABLE_HYPERSCAN=ON \
+ -DENABLE_JEMALLOC=ON \
+ -DENABLE_OPTIMIZATION=ON \
+ -DCMAKE_BUILD_TYPE=Release \
+ ..
+ make
+ make install DESTDIR=$PKG
+cd ..
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+mkdir -p $PKG/var/log/rspamd
+chown rspamd:rspamd $PKG/var/log/rspamd
+chmod 0755 $PKG/var/log/rspamd
+
+mkdir -p $PKG/var/lib/rspamd
+chown rspamd:rspamd $PKG/var/lib/rspamd
+chmod 0750 $PKG/var/lib/rspamd
+
+mkdir -p $PKG/etc/rc.d
+cat $CWD/rc.rspamd.new > $PKG/etc/rc.d/rc.rspamd.new
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a AUTHORS.md CONTRIBUTING.md ChangeLog LICENSE.md README.md \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/rspamd/rspamd.info b/rspamd/rspamd.info
new file mode 100644
index 0000000..0fd4280
--- /dev/null
+++ b/rspamd/rspamd.info
@@ -0,0 +1,10 @@
+PRGNAM="rspamd"
+VERSION="1.9.4"
+HOMEPAGE="https://rspamd.com"
+DOWNLOAD="https://github.com/rspamd/rspamd/archive/1.9.4/rspamd-1.9.4.tar.gz"
+MD5SUM="930b07b1f55dfc9c46abbe266eae9856"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="ragel luajit redis hyperscan"
+MAINTAINER="Ebben Aries"
+EMAIL="e@dscp.org"
diff --git a/rspamd/slack-desc b/rspamd/slack-desc
new file mode 100644
index 0000000..7419034
--- /dev/null
+++ b/rspamd/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+rspamd: rspamd (An advanced spam filtering system)
+rspamd: Rspamd is an advanced spam filtering system that allows evaluation of
+rspamd: messages by a number of rules including regular expressions,
+rspamd: statistical analysis and custom services such as URL black lists.
+rspamd: Each message is analysed by Rspamd and given a spam score.
+rspamd: According to the spam score and the user's settings Rspamd recommends
+rspamd: an action for the MTA to apply to the message: for example, to pass,
+rspamd: to reject or to add a header. Rspamd is designed to process hundreds
+rspamd: of messages per second simultaneously and has a number of features
+rspamd: available.
+rspamd: Home-Page: https://rspamd.com
diff --git a/rspamd/use-gold-ld.patch b/rspamd/use-gold-ld.patch
new file mode 100644
index 0000000..61b1047
--- /dev/null
+++ b/rspamd/use-gold-ld.patch
@@ -0,0 +1,16 @@
+--- a/cmake/Toolset.cmake 2020-02-04 17:00:17.000000000 +0100
++++ b/cmake/Toolset.cmake 2020-02-09 22:11:19.914735934 +0100
+@@ -45,10 +45,10 @@
+ find_program(GOLD_PATH NAMES "ld.gold" "gold")
+
+ if(NOT LINKER_NAME)
+- if(LLD_PATH)
+- set(LINKER_NAME "lld")
+- elseif(GOLD_PATH)
++ if(GOLD_PATH)
+ set(LINKER_NAME "gold")
++ elseif(LLD_PATH)
++ set(LINKER_NAME "lld")
+ else()
+ message(STATUS "Use generic 'ld' as a linker")
+ endif()